package com.emilianomaccaferri.inheritance;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.concurrent.TimeUnit;

public class Alimentary extends Product {

    protected Calendar expiry;

    public Alimentary(String barcode, String description, double price, String date) throws ParseException{

        super(barcode, description, price);
        SimpleDateFormat dateToParse = new SimpleDateFormat("dd/MM/yyyy");
        dateToParse.parse(date);
        this.expiry = dateToParse.getCalendar();

    }


    public long daysToExpiry(){

        Calendar today = Calendar.getInstance();
        long start = today.getTimeInMillis();
        long end = expiry.getTimeInMillis();
        long day = 3600 * 24 * 1000;

        return (Math.abs(end - start) / day);

    }

    @Override
    public void applyDiscount(){

        if(daysToExpiry() < 10)
            super.price = super.price - (20 * super.price) / 100;

    }

    @Override
    public String getBarcode(){

        return super.barcode;

    }

    @Override
    public String description(){

        return super.description;

    }

    @Override
    public double getPrice(){

        return super.price;

    }

}
