package com.emilianomaccaferri.inheritance;


public class Product {

    protected String barcode;
    protected String description;
    protected double price;

    public Product(String barcode, String description, double price){

        this.barcode = barcode;
        this.description = description;
        this.price = price;

    }

    public boolean equalsTo(Object obj){

        // checks if the given object is actually a product and has the same barcode

        if(obj instanceof Product)
            return barcode.equals(((Product) obj).getBarcode());

        return false;

    }

    @Override
    public String toString(){
        return "Barcode: " + this.barcode + ", description: " + this.description + ", price: " + this.price;
    }

    public void applyDiscount(){

        this.price = this.price - (5 * this.price) / 100;

    }

    public String getBarcode(){

        return this.barcode;

    }

    public String description(){

        return this.description;

    }

    public double getPrice(){

        return this.price;

    }

}

